package spitz.ayal.jarjar;

import java.io.IOException;
import java.io.InputStream;
import java.net.URL;
import java.net.URLConnection;
import java.net.URLStreamHandler;
import java.net.URLStreamHandlerFactory;



public class Handler implements URLStreamHandlerFactory{
	
	public URLStreamHandler createURLStreamHandler(String protocol){
		URLStreamHandler		handler = null;
		
		if (protocol.equals("jarjar")){
			handler = new JarJarURLStreamHandler();
		}

		return handler;
	}		
	
	private class JarJarURLStreamHandler extends URLStreamHandler{	
		@Override
		protected URLConnection openConnection(URL url) throws IOException {
			return new JarJarURLConnection(url);
		}
	}

	private class JarJarURLConnection extends URLConnection{
		public JarJarURLConnection(URL url){ super(url); }
		
		@Override
		public void connect() throws IOException{}

		@Override
		public InputStream getInputStream() throws IOException{
			return JarJarClassLoaderMgr.getInstance().getResource(url);
		}
	}
}

